package algae.simulation.agents;
   import java.util.*;
   import java.lang.*;
import function.Function;
   public class CubicSpline implements function.Function {
   
      Vector a; //Cubic Coefficients		
      Vector b;		
      Vector c;
   
      Vector x; //Point Array
      Vector y;
   
      int nPoints; //Number of points
   
   
      CubicSpline(int n,Vector px,Vector py){
         double bh;
         double dh;
         double e;
         double h;
         Double d1;
         Double d2;
         Double d3;
         Double d4;
         Double d5;
         Double d6;
      
         nPoints = n;
         a = new Vector(n);		
         b = new Vector(n);		
         c = new Vector(n);
         x = new Vector(n);
         x = px;
         y = py;
         Vector delta_x = new Vector(n);	
         Vector D = new Vector(n); //Geteilte Differenzen D_i
         Vector m = new Vector(n);
         Vector k = new Vector(n);
      
      
      
         delta_x.setSize(n);
         D.setSize(n);
         m.setSize(n);
         k.setSize(n);
         a.setSize(n);
         b.setSize(n);
         c.setSize(n);
         x.setSize(n);
         y.setSize(n);
      
         for(int i=1;i<=(n-1);i++){
            d1 = (Double)x.get(i);
            d2 = (Double)x.get(i-1);
            delta_x.add(i,new Double(d1.doubleValue()-d2.doubleValue()));
            d1 = (Double)y.get(i);
            d2 = (Double)y.get(i-1);
            d3 = (Double)delta_x.get(i);
         
            D.set(i, new Double((d1.doubleValue() - d2.doubleValue())/d3.doubleValue()));
         }
      	//First Intervall
         d1 = (Double)delta_x.get(2);
         m.set(0,new Double(d1.doubleValue()));
         d1 = (Double)x.get(2);
         d2 = (Double)x.get(0);
         delta_x.set(0, new Double(d1.doubleValue() - d2.doubleValue()));
         d1 = (Double)delta_x.get(1); 
         h = d1.doubleValue();
         d1 = (Double)delta_x.get(0); 
         d2 = (Double)D.get(1); 
         d3 = (Double)delta_x.get(2); 
         d4 = (Double)D.get(2);		
         k.set(0,new Double(((h + 2*d1.doubleValue())*d2.doubleValue()*d3.doubleValue() + h*h*d4.doubleValue())/d1.doubleValue()));			
      
      	//Forward Pass Gauss Elimination
         for(int i=1;i<=(n-2);i++){
            d1 = (Double)delta_x.get(i+1);
            d2 = (Double)m.get(i-1);
            h = -d1.doubleValue()/d2.doubleValue();
            d1 = (Double)k.get(i-1);
            d2 = (Double)delta_x.get(i);
            d3 = (Double)D.get(i+1);
            d4 = (Double)delta_x.get(i+1);
            d5 = (Double)D.get(i);
            k.set(i,new Double(h*d1.doubleValue()+3*(d2.doubleValue()*d3.doubleValue()+d4.doubleValue()*d5.doubleValue())));				
            d1 = (Double)delta_x.get(i-1);
            m.set(i,new Double(h*d1.doubleValue() + 2*(d2.doubleValue()+d4.doubleValue())));		
         
         }
      	//Last Intervall
         d1 = (Double)x.get(n-1);
         d2 = (Double)x.get(n-3);
         h = d1.doubleValue()- d2.doubleValue();
         d1 = (Double)delta_x.get(n-1);
         dh = d1.doubleValue();
         d1 = (Double)D.get(n-1);
         d2 = (Double)delta_x.get(n-2);
         d3 = (Double)D.get(n-2);
         k.set(n-1,new Double(((dh+h+h)*d1.doubleValue()*d2.doubleValue()+dh*dh*d3.doubleValue())/h));
         d1 = (Double)m.get(n-2);
         h = -h/d1.doubleValue();
      	//Complete Forward Pass Gauss
         m.set(n-1,new Double((h+1)*d2.doubleValue()));
      
      
      	//Back Substitution Gauss
         d1 = (Double)k.get(n-2);
         d2 = (Double)k.get(n-1);
         d3 = (Double)m.get(n-1);
         a.set(n-1,new Double((h*d1.doubleValue()+d2.doubleValue())/d3.doubleValue()));
         for(int i=n-2;i>=0;i--){
            d1 = (Double)k.get(i);
            d2 = (Double)delta_x.get(i);
            d3 = (Double)a.get(i+1);
            d4 = (Double)m.get(i);
            a.set(i,new Double((d1.doubleValue()-d2.doubleValue()*d3.doubleValue())/d4.doubleValue()));
         }
      
      
      	//Generate Cubic Coefficients 
         for(int i=1;i<=(n-1);i++){
            d1 = (Double)D.get(i);
            dh = d1.doubleValue();
            d1 = (Double)delta_x.get(i);
            bh = d1.doubleValue();
            d1 = (Double)a.get(i-1);
            d2 = (Double)a.get(i);
            e = d1.doubleValue()+d2.doubleValue()-dh-dh;
            b.set(i-1,new Double((dh-d1.doubleValue()-e)/bh));
            c.set(i-1,new Double(e/bh*bh));
         
         }
      }
      public double getValue(double px){
      
         int run;
         double diff;
         Double d1;
         Double dn;
         Double dy;
         Double da;
         Double db;
         Double dc;
      
         d1 =  (Double)x.get(0);
         dn =  (Double)x.get(nPoints-1);
      
      
      
         if (px <= d1.doubleValue()){
         
            return d1.doubleValue();
         } 
         else if(px >= dn.doubleValue()){
           
            return dn.doubleValue();
         } 
         else {
            run = 0;
            d1 =  (Double)x.get(run);
            while (px > d1.doubleValue()){
               run = run + 1;
               d1 =  (Double)x.get(run);
            }
            d1 =  (Double)x.get(run-1);
            diff = px - d1.doubleValue();
            dy = (Double)y.get(run-1);
            da = (Double)a.get(run-1);
            db = (Double)b.get(run-1);
            dc = (Double)c.get(run-1);
            return dy.doubleValue() + da.doubleValue()*diff + db.doubleValue()*diff*diff + dc.doubleValue()*diff*diff*diff;
         }
      
      }
      public float getValue(float px){
	  return( (float) getValue((double)px));
      }
   }

