package algae.simulation.worlds;
import java.util.*;

import algae.simulation.Settings;
import algae.simulation.view.ViewPheromone;
import java.io.IOException;
import algae.simulation.SinCosLut;
/** A class that represents ...
 * 
 * @see OtherClasses
 * @author your_name_here
 */
public class PheromoneWorld extends World {
  
    final double RESOLVERATE;
    
    SinCosLut lut;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	int stepsToResolve;
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;
		this.stepsToResolve = 0;
	    }
	
	public Element(double amount, int dec)
	    {
		this.amount = amount;
		this.stepsToResolve = dec;
	    }
	
	// Operations
	
	public boolean exists()
	    {
		return ((this != null) && (this.amount > 0));
	    }
	    
	public boolean add(int steps)
	{
	    return true;
	}
	
	public boolean put(float amount) 
	    {
	    	if (this.amount+amount<=cfg.max_pheromone_saturation) 
	    	{
	    	   this.amount += amount;
		   this.stepsToResolve = (int)(1/RESOLVERATE);
		   renew++;
		}
		return true;
		
	    } //deplete
	
	public boolean remove(int steps)
	{
		return true;
	}
	
	boolean update()
	    {
	    	if (this.amount<=0)
	    	   return true;
		if ((this.stepsToResolve>0)&&(this.amount>0))
		{
		    stepsToResolve--;
		}
		else 
		{
		    this.amount--;
		    if (this.amount<0)
		       this.amount=0;
		    used++;
		    stepsToResolve=(int)(1/RESOLVERATE);
		}
		return true;
	    } // update
	
    }// end class Element
    
    public PheromoneWorld(Settings set, SinCosLut scl) 
    {
	super(set.height, set.width);
	lut=scl;
	cfg=set;
	this.RESOLVERATE = set.pheromone_dec_rate;
        
        for (int i=0; i<set.height; i++)
            for (int j=0; j<set.width; j++)
                this.world[i][j]=new Element(0.0,0);
    }

    public void set(int x, int y)
    {
    	int dx=0;
    	int dy=0;
    	int ox=0;
    	int oy=0;
    	float rfac=90.0f/(float)cfg.pheromone_radius;
    	for (int r=0; r<cfg.pheromone_radius; r++)
    	{
    	    for (int angle=0; angle<360; angle+=10)
    	    {
    	    	dx=(int)(x+r*lut.fCos(angle));
    	        dy=(int)(y+r*lut.fSin(angle));
    	        
    	        if ((dx!=ox)||(dy!=oy))
    	        if ((dx>=0)&&(dx<cfg.width)&&(dy>=0)&&(dy<cfg.height))
    	           if (this.world[dy][dx].put(2*lut.fCos((int)(rfac*r)))) {}	       
    	        
    	        ox=dx; oy=dy;
    	    }
	}
    }

    public void step(int step)
    {
	for(int i = 0; i < cfg.height; i++) 
	    {	    
		for(int j = 0; j < cfg.width;j++) 
		    {
			  this.world[i][j].update();
		    }
	    }
    }

    public ViewPheromone[]  getList()
    {
	ViewPheromone ret[];
	int retC=0;
	
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if (this.world[i][j].amount>0.0)
			    retC++;
		    }
	    }
	
	int z=0;
	
	if (retC==0)
	   return null;
	
	ret=new ViewPheromone[retC];
	
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if (this.world[i][j].amount>0.0)
		        {
			    ret[z]=new ViewPheromone(j,i,this.world[i][j].value(j,i));
			    z++;
			}
		    }
	    }
	return ret;
    }//getList

  // Operations

} /* end class PheromoneWorld */
