
/**
 * GraphPanel.java
 *
 *
 * Created: Sat May 05 09:02:47 2001
 *
 * @author 
 * @version
 */
package function;


import java.lang.Float;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import function.Function;

public class GraphPanel extends JLabel {
    
    Function function;
    float x0 = Float.MIN_VALUE; 
    float xn = Float.MAX_VALUE; 
    float y0 =Float.MIN_VALUE; 
    float ym = Float.MAX_VALUE;

    public GraphPanel() {
	super();
	function = null;
    }

    public GraphPanel(Function f)
    {
	super();
	setFunction(f);
    }

    public GraphPanel(Function f, 
		      float x0, float xn,
		      float y0, float ym)
    {
	setFunction(f);
	setRange(x0, xn , y0 ,ym);
    }

    public void setFunction(Function f)
    {
       function = f;
    }
    
    public void setRange(float x1, float x2,
			 float y1, float y2)
    {
	x0 = x1;
	xn = x2;
	y0 = y1;
	ym = y2;
    }

    protected void paintComponent(Graphics g)
    {
	Hashtable tupel = new Hashtable();
	float maxy = Float.MIN_VALUE;
	float miny = Float.MAX_VALUE;
	
	Insets insets = getInsets();
	int currentWidth = getWidth() - insets.left - insets.right;
	int currentHeight = getHeight() - insets.top - insets.bottom;
		
	float xStep = (xn - x0) / (float)currentWidth;
	float yStep;
		
	Graphics gr = getGraphics();

	if(function != null)
	    {
		super.paintComponent(gr);

			
		for(float x = x0 + xStep; x <= xn;x += xStep)
		    {
			float y = function.getValue(x);

			tupel.put(new Float(x), new Float(y));
			
			if(y > maxy)
			    {
				maxy = y;
			    }

			if(y >= miny)
			    {
				miny = y;
			    }
		    }

		yStep = (maxy - miny) / (float)currentHeight;
		
		gr.translate((int)(xn/xStep),
			     (int)(maxy/yStep));

		// set cap
		// draw x-axis
		gr.drawLine(0,currentWidth - currentWidth/2 ,0,currentWidth/2);
		//draw y-axis
		gr.drawLine(currentHeight - currentHeight/2,0,currentHeight/2,0);
		// unset cap

		Iterator k = tupel.keySet().iterator();

		float lastx = (((Float)k.next()).floatValue() / -xStep);
		float lasty = ((Float) tupel.get(new Float(lastx))).floatValue();
		while(k.hasNext())
		    {
			float x = (((Float)k.next()).floatValue() / -xStep);
			float y = ((Float) tupel.get(new Float(lastx))).floatValue();
		
			gr.drawLine((int)lastx, (int)lasty, (int)x, (int)y);
		
			lastx = x;
			lasty =y;
		    }
	    }//if funtion != null

    }//paintComponent
    
} // GraphPanel
