package netView;

import netView.*;

import java.awt.*;         
import java.awt.event.*;
import javax.swing.*;
import java.awt.BorderLayout;
import java.math.*;
import java.util.Enumeration;
import java.awt.event.InputEvent;

final class ANNPanel2D extends NetPanel 
    implements KeyListener, MouseListener, MouseMotionListener {

    // Canvas3D c3d;
    //	View v;

    Color connColor=new Color(160,160,160,255);
    
    Netview netView=null;

    String []inputNames;
    String []outputNames;
    
    int x[],y[];
    int connections[][];
    boolean displayList[];
    float weightValues[];

    boolean showUnusedHiddenLayerNeurons=false;
    
    int inCount=0;
    int hiddenCount=0;
    int outCount=0;
    int nCount=0;
    int connCount=0;
	
    byte neuronMatrix[][];
    float weightMatrix[][];
    float netOutput[];	
	
    //	BranchGroup objRoot = new BranchGroup();
	
    int mouseX=-1, mouseY=-1;
    int selectedNeuron=-1;
    int selectedConnection=-1;

    //******************************************************************************
    //* public void ANNPanel2D(int inCount, int hiddenCount, int outCount, byte neuron_matrix[][], float weight_matrix[][], float netOut[])
    //*    Constructor of the class
    //******************************************************************************
    // 	public ANNPanel2D(int inCount, int hiddenCount, int outCount, byte neuron_matrix[][], float weight_matrix[][], float netOut[]) {
    // 		initVars(inCount,hiddenCount,outCount,neuron_matrix,weight_matrix,netOut);
    // 		setupPanel();
    // 	}

    public void resetData(Netview nv, 
		      byte[][] connections, float[][] weights, 
		      int[] inputIndices, int[] outputIndices)
    {
    	netView=nv;
			
	int neuronCount=connections.length;				
	int inCount=inputIndices.length;
	int outCount=outputIndices.length;
	int hiddenCount=neuronCount-inCount-outCount;
		
	float netOut[]=new float[neuronCount]; // dummy values - weil nix im konstruktor bergeben wird
	initVars(inCount,hiddenCount,outCount,connections,weights,netOut);
	setupPanel();
    }
	    
    public ANNPanel2D(Netview nv, 
		      byte[][] connections, float[][] weights, 
		      int[] inputIndices, int[] outputIndices)
    {
    	super(nv,connections, weights, inputIndices, outputIndices);
	netView=nv;
			
	int neuronCount=connections.length;				
	int inCount=inputIndices.length;
	int outCount=outputIndices.length;
	int hiddenCount=neuronCount-inCount-outCount;
		
	float netOut[]=new float[neuronCount]; // dummy values - weil nix im konstruktor bergeben wird
	initVars(inCount,hiddenCount,outCount,connections,weights,netOut);
	setupPanel();
    }
	

    // keylistener stuff
    public void keyPressed(KeyEvent e)
    {
	
    }

    public void keyReleased(KeyEvent e)
    {
	
    }

    public boolean isFocusTraversable()
    {
	return true;
    }

    public void keyTyped(KeyEvent e)
    {
	// cycle through neurons
	if (e.getKeyChar()=='.')
	    {
		selectedNeuron++;
		if (selectedNeuron>nCount-1)
		    selectedNeuron=0;      		   
	    	while (!displayList[selectedNeuron])
	    	{
		      selectedNeuron++;
		      if (selectedNeuron>nCount-1)
		         selectedNeuron=0;      		   
		}
		this.repaint();
		
		if (netView!=null)
		    netView.selectedNeuron(selectedNeuron);
	    }
	if (e.getKeyChar()==',')
	    {
	    	selectedNeuron--;
		if (selectedNeuron<0)
		    selectedNeuron=nCount-1;
	    	while (!displayList[selectedNeuron])
	    	{
		      selectedNeuron--;
		      if (selectedNeuron<0)
		         selectedNeuron=nCount-1;
		}
		this.repaint();
		
		if (netView!=null)
		    netView.selectedNeuron(selectedNeuron);
	    }
		
	// 		// cycle through connections
	// 		if (e.getKeyChar()=='m')
	// 		{
	// 		   selectedConnection++;
	// 		   if (selectedConnection > connCount)
	// 		      selectedConnection=0;      		   
	// 		   this.repaint();
	
	// 		   if (netView!=null)
	// 		      netView.selectedConnection(selectedConnection,weightValues[selectedConnection]);
	// 		}
		
	// 		if (e.getKeyChar()=='n')
	// 		    {
	// 			selectedConnection--;
	// 			if (selectedConnection<0)
	// 			    selectedConnection=connCount;
	// 			this.repaint();
	
	// 			if (netView!=null)
	// 			    netView.selectedConnection(selectedConnection,weightValues[selectedConnection]);
	//  		    }
    }//TYPED
		
    // mouselistener stuff
    public void mouseMoved(MouseEvent e) {
	mouseX=e.getX();
	mouseY=e.getY();
	
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseDragged(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }
    
    public void mouseExited(MouseEvent e) {
	mouseX=-1;
	mouseY=-1;
    }
    	
    public void mouseClicked(MouseEvent e) {
	mouseX=e.getX();
	mouseY=e.getY();
	
	int nearest=-1;
	
	int nx=10000;
	int ny=10000;
	
	for (int i=0; i<nCount; i++)
	    {
		int dx=Math.abs(mouseX-x[i]);
		int dy=Math.abs(mouseY-y[i]);
		
		if ((dx<=15)&&(dy<=15))
    		    {
    		    	nearest=i;
    		    	break;
    		    }
	    }	
    		
	if (nearest!=-1)
	    {
		selectedNeuron=nearest;
		this.repaint();
		if (netView!=null)
		    netView.selectedNeuron(selectedNeuron);
	    }
    }
    
    public void buildDisplayList()
    {
    	displayList=new boolean[nCount];
    	
    	for (int i=0; i<nCount; i++)
    	{
    	    if (i<inCount+outCount)
    	    	displayList[i]=true;
    	    else
    	    	displayList[i]=false;
    	}
    	    
    	for (int i=0; i<nCount; i++)
	    for (int j=0; j<nCount; j++)
		{
		    if ((i<j)&&(neuronMatrix[i][j]!=0))
		    	{
			     displayList[i]=true;
			     displayList[j]=true;
		    	}
		}    	
    }
    
    public int getNumberOfActiveNeurons()
    {
    	int retVal=0;
    	for (int n=0; n<nCount; n++)
    	    if (displayList[n])
    	    	retVal++;
    	    	
    	  return retVal;
    }

    public void preCalcCoordinates() {
	
	int sizeX=0,sizeY=0;
		
	// allocate our arrays for the positions of the neurons
	x=new int[nCount];
	y=new int[nCount];
			
	// coordinates for input-neurons
	for (int z=0; z<inCount; z++)
	    {
		x[z]=(z*35)+300-((inCount/2)*35);
		y[z]=480+20;

		if (x[z]>sizeX)
		   sizeX=x[z];
		if (y[z]>sizeY)
		   sizeY=y[z];
	    }
				
	// coordinates for hidden-neurons
	float degStep=360.0f/(float)hiddenCount;
	for (int z=inCount+outCount; z<nCount; z++)
	    {
		x[z]=(int)(300.0f+150.0f*(float)Math.cos((double)((float)z*degStep/180.0f*Math.PI)));  
		y[z]=20+(int)(250.0f+150.0f*(float)Math.sin((double)((float)z*degStep/180.0f*Math.PI)));

		if (x[z]>sizeX)
		   sizeX=x[z];
		if (y[z]>sizeY)
		   sizeY=y[z];
	    }		
		
	// coordinates for output-neurons
	for (int z=inCount; z<inCount+outCount; z++)
	    {
		x[z]=((z-inCount)*35)+300-((outCount/2)*35);
		y[z]=20+20;

		if (x[z]>sizeX)
		   sizeX=x[z];
		if (y[z]>sizeY)
		   sizeY=y[z];
	    }		
	    
	// 

	sizeX+=30;
	sizeY+=50;
	
	this.setPreferredSize(new Dimension(sizeX,sizeY));	
    }

    public void preCalcConnections()
    {
	connections=new int[connCount][2];
	weightValues=new float[connCount];
		
	int tmp=0;
	// add weight line stuff
	for (int i=0; i<nCount; i++)
	    for (int j=0; j<nCount; j++)
		{
		    if (/*(i<j)&&*/(neuronMatrix[i][j]!=0))
		    	{
			    connections[tmp][0]=i;
			    connections[tmp][1]=j;
			    weightValues[tmp]=weightMatrix[i][j];
			    tmp++;
		    	}
		}    	
    }

    public void setupPanel() {
	addMouseMotionListener(this);
	addMouseListener(this);
	addKeyListener(this);
    }

    //******************************************************************************
    //* public void initVars(int iC, int hC, int oC, byte nm[][], float wm[][], float nO[])
    //*    transfer the values from the constructor to local variables
    //******************************************************************************
    public void initVars(int iC, int hC, int oC, byte nm[][], float wm[][], float nO[]) {

	inCount=iC;
	hiddenCount=hC;
	outCount=oC;
	nCount=inCount+hiddenCount+outCount;
	
	neuronMatrix=new byte[nCount][nCount];
	weightMatrix=new float[nCount][nCount];
	netOutput=new float[nCount];

	// get neuron strings out of netview
	inputNames=netView.getInNeuronsNames();
	outputNames=netView.getOutNeuronsNames();
	
	for (int i=0; i<nCount; i++)
	    for (int j=0; j<nCount; j++)
		{
		    neuronMatrix[i][j]=nm[i][j];
		    weightMatrix[i][j]=wm[i][j];
		    netOutput[i]=nO[i];
		}	
		    
	connCount=0;
	for (int i=0; i<nCount; i++)
	    for (int j=0; j<nCount; j++)
		{
		    if (/*(i<j)&&*/(neuronMatrix[i][j]!=0))
		    	{
			    connCount++;
		    	}
		}
 
        buildDisplayList();
	preCalcCoordinates();
	preCalcConnections();

	repaint();
    }
    
    public void ShowInactiveHiddenNeurons(boolean b)
    {
    	showUnusedHiddenLayerNeurons=b;
    }

    public void paintNeurons(Graphics g)
    {
	for (int z=0; z<nCount; z++)
	    {
	    	if ((!displayList[z])&&(!showUnusedHiddenLayerNeurons)) continue;
	    	
		if (selectedNeuron==z)
		    {
		    	g.setColor(Color.yellow);
		    }
		else
		    {
		    	if (z<inCount)
			    g.setColor(Color.red);
		    	if (z>=inCount+outCount)
			    g.setColor(Color.green);
		    	if ((z>=inCount)&&(z<inCount+outCount))
			    g.setColor(Color.blue);
			    	
		    }
		    
		g.fillOval(x[z]-15,y[z]-12,30,30);
		g.setColor(Color.black);
	
		if (z<inCount)
		   if (z%2==0)
		      g.drawString(inputNames[z],x[z]-15,y[z]+30);
		   else
		      g.drawString(inputNames[z],x[z]-15,y[z]+45);

		// paint index of neuron (for each neuron)
		g.drawString(Integer.toString(z),x[z]-7,y[z]+7);

		if ((z>=inCount)&&(z<inCount+outCount))
		   g.drawString(outputNames[z-inCount],x[z]-15,y[z]-15);
	    }
    }

    public void paintConnections(Graphics g)
    {
  
	int tmp=0;
	
	if (selectedNeuron==-1)
	{
	// paint connections
	for (int i=0; i<connCount; i++)
	    {
		if (i==selectedConnection)
		    {
		        g.setColor(Color.yellow);
		        g.drawLine(x[connections[i][0]],y[connections[i][0]],x[connections[i][1]],y[connections[i][1]]);
		    }
		else
		{
	            g.setColor(connColor);		 
		    g.drawLine(x[connections[i][0]],y[connections[i][0]],x[connections[i][1]],y[connections[i][1]]);
		}
	    }
	}
	else
	{
	    for (int i=0; i<connCount; i++)
	    {
		if ((connections[i][0]!=selectedNeuron)&& 
		    (connections[i][1]!=selectedNeuron))
		{
	            g.setColor(connColor);		 
		    g.drawLine(x[connections[i][0]],y[connections[i][0]],x[connections[i][1]],y[connections[i][1]]);
		}
	    }
	    for (int i=0; i<connCount; i++)
	    {
		if (connections[i][0]==selectedNeuron) // ausgehende verbindung = rot
		{
            	    g.setColor(Color.red);
		    g.drawLine(x[connections[i][0]],y[connections[i][0]],x[connections[i][1]],y[connections[i][1]]);
		}
		else 
		if (connections[i][1]==selectedNeuron) // eingehende verbindung = blau
		{
                    g.setColor(Color.blue);
		    g.drawLine(x[connections[i][0]],y[connections[i][0]],x[connections[i][1]],y[connections[i][1]]);
		}    
	    }
	}	
        g.setColor(Color.black);	    	      
    }

    public void paintTextStuff(Graphics g)
    { 
	g.setColor(Color.black);
	for (int z=0; z<nCount; z++)
	    {
		String tmp=Float.toString(netOutput[z]);
		g.drawString(tmp,x[z]-8,y[z]+8);
	    }
    }

    public void update(Graphics g)
    {
	paintConnections(g);
	paintNeurons(g);
	//paintTextStuff(g);
    }
	
    public void paintComponent(Graphics g)
    {
	super.paintComponent(g);
	this.update(g);
    }

    public void selectNeuron(int idx)
    {
	if ((idx>=0)&&(idx<=nCount))
	    selectedNeuron=idx;
    }

    public void selectConnection(int idx)
    {
	if ((idx>=0)&&(idx<=connCount))
	    selectedConnection=idx;
    }
	
    public int getConnectionCount()
    {
	return connCount;
    }
	
    public int[][] getConnections()
    {
	return connections;
    }
	
    public int getSelectedNeuron()
    {
	return selectedNeuron;
    }
 
    int getSelectedConnection()
    {
	return selectedConnection;	
    }

    void unSelectNeuron()
    {
	selectedNeuron=-1;
    }

    void unSelectConnection()
    {
	selectedConnection=-1;
    }

/*
DONE: -bei select : ein und ausgnge anzeigen
DONE: -bentigte gre ermitteln und auf this mit setpreferredsize
DONE: -agent implements netviewsource
DONE: -netOut zurckliefern
     
-  einzelschritt -> button -> annview und eigenen Frame aufmachen
   und Men in Frame einbauen
*/


}//ANNPanel2D
