package netView;

import netView.*;

import java.awt.*;         
import java.awt.event.*;
import javax.swing.*;
import java.awt.BorderLayout;
import java.math.*;
import java.util.Enumeration;
import java.awt.event.InputEvent;

import javax.media.j3d.*;     
import javax.vecmath.*;    
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import javax.media.j3d.ColoringAttributes;

public final class ANNPanel3D extends NetPanel implements MouseListener, MouseMotionListener {

	Netview netView=null;

	Canvas3D c3d;
	View v;
	
	BranchGroup objRoot = new BranchGroup();

	int inCount=0;
	int hiddenCount=0;
	int outCount=0;
	int nCount=0;
	
	byte neuronMatrix[][];
	float weightMatrix[][];
	float netOutput[];	
	
	int mouseX=-1, mouseY=-1;

	public void mouseMoved(MouseEvent e) {
    		mouseX=e.getX();
    		mouseY=e.getY();
    	}

    	public void mousePressed(MouseEvent e) {
    	}

    	public void mouseDragged(MouseEvent e) {
    	}

    	public void mouseReleased(MouseEvent e) {
    	}

    	public void mouseEntered(MouseEvent e) {
    	}

    	public void mouseExited(MouseEvent e) {
    		mouseX=-1;
    		mouseY=-1;
    	}

    	public void mouseClicked(MouseEvent e) {
    	}

	//******************************************************************************
	//* public int getConnectionCount()
	//*    determine the number of connections in the ANN
	//******************************************************************************
	public int getConnectionCount() {
		int tmp=0;
		for (int i=0; i<nCount; i++)
		    for (int j=0; j<nCount; j++)
		    	if ((neuronMatrix[i][j]!=0)&&(i!=j))
		    	   tmp++;
		return tmp;
	}


	//******************************************************************************
	//* public void setupScene()
	//*    construct the whole scene geometry
	//******************************************************************************
	public void setupScene() {
				
		BranchGroup sceneRoot=new BranchGroup();
		TransformGroup sceneRotate=new TransformGroup();
		sceneRotate.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		sceneRotate.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
				
		objRoot.addChild(sceneRotate);
		
		// add mouse steering behaviour
		MouseRotate myMouseRotate = new MouseRotate();
		myMouseRotate.setFactor(0.01f);
		myMouseRotate.setTransformGroup(sceneRotate);
		myMouseRotate.setSchedulingBounds(new BoundingSphere());
		objRoot.addChild(myMouseRotate);
		
		MouseZoom myMouseZoom = new MouseZoom();
		myMouseZoom.setFactor(0.01f);
		myMouseZoom.setTransformGroup(sceneRotate);
		myMouseZoom.setSchedulingBounds(new BoundingSphere());
		objRoot.addChild(myMouseZoom);
		
		// setup geometry
		Transform3D tf3D[] = new Transform3D[nCount];
		TransformGroup tg[] = new TransformGroup[nCount];
		
		Appearance appear[] = new Appearance[nCount];
		Material mat[] = new Material[nCount];

		// determine number of connections in the current ANN
		int connCount=getConnectionCount();
		LineArray line[]=new LineArray[connCount];
		
		Point3f point[]=new Point3f[nCount];

		// precalculate points for nodes and connections
		// for input nodes
		for (int z=0; z<inCount; z++)
			point[z]=new Point3f((float)(z-inCount/2)*1.0f/(float)inCount,-0.5f,0.0f);
			
		// for hidden nodes
		for (int z=inCount+outCount; z<nCount; z++)
		{
			float dx=(float)Math.cos((double)((float)(z-inCount-outCount)*(360.0f/(float)hiddenCount)/180.0f*Math.PI))/2.0f;//(float)((float)hiddenCount/10.0f);
			float dz=(float)Math.sin((double)((float)(z-inCount-outCount)*(360.0f/(float)hiddenCount)/180.0f*Math.PI))/2.0f;//(float)((float)hiddenCount/10.0f);

			point[z]=new Point3f(dx,0.0f,-dz);
			System.out.println("ANNPANEL3D: hidden layer neurons: "+hiddenCount);
			System.out.println("ANNPANEL3D: adding hidden layer neuron: "+z);
		}
		//for output nodes
		for (int z=inCount; z<inCount+outCount; z++)
			point[z]=new Point3f((float)(z-inCount-outCount/2)*1.0f/(float)outCount,0.5f,0.0f);
		
		// add node geometry for input layer
		for (int z=0; z<inCount; z++)
		{
	   	    tf3D[z]=new Transform3D();					
		    tf3D[z].set(new Vector3f(point[z].x,point[z].y,point[z].z));
		    tg[z]=new TransformGroup(tf3D[z]);
		
		    appear[z]=new Appearance();
		    appear[z].setColoringAttributes(new ColoringAttributes(1.0f,0.0f,0.0f,ColoringAttributes.SHADE_GOURAUD));
	            mat[z]=new Material();
		    mat[z].setDiffuseColor(1.0f,0.0f,0.0f);
		    appear[z].setMaterial(mat[z]);
		
		    tg[z].addChild(new Sphere(0.02f,appear[z]));
	            sceneRotate.addChild(tg[z]);
		}		

		// add node geometry for hidden layer
		for (int z=inCount+outCount; z<nCount; z++)
		{
	   	    tf3D[z]=new Transform3D();					
		    tf3D[z].set(new Vector3f(point[z].x,point[z].y,point[z].z));
		    tg[z]=new TransformGroup(tf3D[z]);
		
		    appear[z]=new Appearance();
		    appear[z].setColoringAttributes(new ColoringAttributes(1.0f,0.0f,0.0f,ColoringAttributes.SHADE_GOURAUD));
	            mat[z]=new Material();
		    mat[z].setDiffuseColor(0.0f,1.0f,0.0f);
		    appear[z].setMaterial(mat[z]);
		
		    tg[z].addChild(new Sphere(0.02f,appear[z]));
	            sceneRotate.addChild(tg[z]);
		}		
		
		// add node geometry for output layer
		for (int z=inCount; z<inCount+outCount; z++)
		{
	   	    tf3D[z]=new Transform3D();					
		    tf3D[z].set(new Vector3f(point[z].x,point[z].y,point[z].z));
		    tg[z]=new TransformGroup(tf3D[z]);
		
		    appear[z]=new Appearance();
		    appear[z].setColoringAttributes(new ColoringAttributes(1.0f,0.0f,0.0f,ColoringAttributes.SHADE_GOURAUD));
	            mat[z]=new Material();
		    mat[z].setDiffuseColor(0.0f,0.0f,1.0f);
		    appear[z].setMaterial(mat[z]);
		
		    tg[z].addChild(new Sphere(0.02f,appear[z]));
	            sceneRotate.addChild(tg[z]);
		}				
					
		// add weight line geometry
		int lineC=-1;
		for (int i=0; i<nCount; i++)
		    for (int j=0; j<nCount; j++)
		    {
		    	if ((neuronMatrix[i][j]!=0)&&(i!=j))
		    	{
		    	   lineC++;
		    	   System.out.println("ANNPANEL3D: adding line "+(lineC+1));
		    	  
		    	   line[lineC]=new LineArray(2,LineArray.COORDINATES | LineArray.COLOR_3);
		    	   line[lineC].setCoordinate(0,point[i]);
		    	   line[lineC].setCoordinate(1,point[j]);
		    	   if (i<inCount) // neuron of input layer
		    	   	line[lineC].setColor(0,new Color3f(1.0f,0.0f,0.0f));
		    	   else
		    	   if ((i>=inCount+outCount)&&(i<nCount)) // neuron of hidden layer
		    	   	line[lineC].setColor(0,new Color3f(0.0f,1.0f,0.0f));
		    	   else
		    	   	line[lineC].setColor(0,new Color3f(0.0f,0.0f,1.0f)); //output

		    	   if (j<inCount) // neuron of input layer
		    	   	line[lineC].setColor(1,new Color3f(1.0f,0.0f,0.0f));
		    	   else
		    	   if ((j>=inCount+outCount)&&(j<nCount)) // neuron of hidden layer
		    	   	line[lineC].setColor(1,new Color3f(0.0f,1.0f,0.0f));
		    	   else
		    	   	line[lineC].setColor(1,new Color3f(0.0f,0.0f,1.0f)); //output
		    	   
		    	   sceneRotate.addChild(new Shape3D(line[lineC]));
		    	}
		    }
					
		// add a light to the scene
		DirectionalLight light=new DirectionalLight(/*new Color3f(0.0f,0.0f,1.0f),new Vector3f(1.0f,0.0f,0.5f)*/);
		light.setColor(new Color3f(1.0f,1.0f,1.0f));
		light.setDirection(new Vector3f(0.5f,-0.5f,-1.0f));
		light.setInfluencingBounds(new BoundingSphere());
		objRoot.addChild(light);
			
		// compile the scene
		objRoot.compile();

		// make it visual through a SimpleUniverse
		SimpleUniverse simpleU=new SimpleUniverse(c3d);
		simpleU.getViewingPlatform().setNominalViewingTransform();
		simpleU.addBranchGraph(objRoot);
	}

	//******************************************************************************
	//* public void setupPanel()
	//*    setup the geometry and add the canvas3d to the panel
	//******************************************************************************
	public void setupPanel() {
		c3d=new Canvas3D(null);
		
		setupScene();
		
		setLayout(new BorderLayout());
		add(c3d,BorderLayout.CENTER);		
	}

	//******************************************************************************
	//* public void initVars(int iC, int hC, int oC, byte nm[][], float wm[][], float nO[])
	//*    transfer the values from the constructor to local variables
	//******************************************************************************
	public void initVars(int iC, int hC, int oC, byte nm[][], float wm[][], float nO[]) {

		inCount=iC;
		hiddenCount=hC;
		outCount=oC;
		nCount=inCount+hiddenCount+outCount;
	
		neuronMatrix=new byte[nCount][nCount];
		weightMatrix=new float[nCount][nCount];
		netOutput=new float[nCount];
	
		for (int i=0; i<nCount; i++)
		    for (int j=0; j<nCount; j++)
		    { 
		    	neuronMatrix[i][j]=nm[i][j];
		    	weightMatrix[i][j]=wm[i][j];
		    	netOutput[i]=nO[i];
		    }	

	}

/*
        select(idx)
        verbindungswerte()
        mit keys neuronen durchschalten
        (alles auch bei 2d-panel ansehen)

	neuer kon
        netview connections weights inputIndices outputIndices 
        
        klasse: netview mit selected(idx)        
*/       

	//******************************************************************************
	//* public void ANNPanel3D(int inCount, int hiddenCount, int outCount, byte neuron_matrix[][], float weight_matrix[][], float netOut[])
	//*    Constructor of the class
	//******************************************************************************
	public ANNPanel3D(Netview nv, 
		      byte[][] connections, float[][] weights, 
		      int[] inputIndices, int[] outputIndices) 
	{
    
	 	super(nv,connections, weights, inputIndices, outputIndices);
		netView=nv;
			
		int neuronCount=connections.length;				
		int inCount=inputIndices.length;
		int outCount=outputIndices.length;
		int hiddenCount=neuronCount-inCount-outCount;
		
		float netOut[]=new float[neuronCount]; // dummy values - weil nix im konstruktor bergeben wird
		initVars(inCount,hiddenCount,outCount,connections,weights,netOut);
	                  	
		setupPanel();
	}

	public void resetData(Netview nv, 
		      byte[][] connections, float[][] weights, 
		      int[] inputIndices, int[] outputIndices) 
	{
    
	 	netView=nv;
			
		int neuronCount=connections.length;				
		int inCount=inputIndices.length;
		int outCount=outputIndices.length;
		int hiddenCount=neuronCount-inCount-outCount;
		
		float netOut[]=new float[neuronCount]; // dummy values - weil nix im konstruktor bergeben wird
		initVars(inCount,hiddenCount,outCount,connections,weights,netOut);
	                  	
		setupPanel();
	}

        public void selectNeuron(int idx)
        {
        }

    	public void selectConnection(int idx)
    	{
    	}
	
}