
/**
 * ConnectionTable.java
 *
 *
 * Created: Thu Apr  5 23:27:25 2001
 *
 * @author Clemens Bauer
 * @version
 */
package netView;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.lang.*;
import java.util.Vector;

class ConnectionTable extends JPanel {

    JList inList;
    JList outList;
    Vector currentInData;
    Vector currentOutData;

    public ConnectionTable () {	
	super();

	currentInData = new Vector();
	currentOutData = new Vector();
	
 	GridBagLayout g = (new GridBagLayout());
 	GridBagConstraints c = new GridBagConstraints();

 	this.setLayout(g);
	setBorder(BorderFactory.createTitledBorder("connection data"));

	inList = new JList(currentInData);
	outList = new JList(currentOutData);       
	
// 	c.fill = GridBagConstraints.BOTH;
 	c.anchor = GridBagConstraints.NORTH;

 	c.gridx = 0;
 	c.gridy = 0;
	// 	c.anchor = GridBagConstraints.NORTHWEST;
	JLabel labelIn = new JLabel("#in/weight/value");
 	g.setConstraints(labelIn, c);
	add(labelIn);
	
	//	c.anchor = GridBagConstraints.NORTHEAST;
	c.gridx = 1;
	JLabel labelOut = new JLabel("#out/weight");
	g.setConstraints(labelOut, c);
	add(labelOut);

	//	c.anchor = GridBagConstraints.SOUTHWEST;
 	c.gridy = 1;
	c.gridx = 0;
	c.weighty = 1.0;	
 	g.setConstraints(inList, c);
 	add(inList);

	//	c.anchor = GridBagConstraints.SOUTHEAST;
 	c.gridx = 1;
 	g.setConstraints(outList, c);
	add(outList);
	
    }

    public void addInput(int index, float weight){
	
	String[] row = {Integer.toString(index),Float.toString(weight), "-"};
	
	currentInData.add(join('/', row));
	inList.setListData(currentInData);
    }

    public void addInput(int index, float weight, 
			 float value){

	String[] row = {Integer.toString(index),Float.toString(weight), Float.toString(value)};

	currentInData.add(join('/', row));
	inList.setListData(currentInData);
    }

    public void addOutput(int index, float weight){

	String[] row = {Integer.toString(index),Float.toString(weight)};

	currentOutData.add(join('/', row));
	outList.setListData(currentOutData);
    }

    public void clearTables(){
	currentInData = new Vector();
	inList.setListData(currentInData);
	
	currentOutData = new Vector();
	outList.setListData(currentOutData);
    }
    
    public String join (char c, String[] s){
	
	StringBuffer str = new StringBuffer();

	for(int i = 0; i < s.length;i++){
	    if(i != 0)
		str.append(c);
	    
	    str.append(s[i]);
	}
	
	return str.toString();
    }

}// ConnectionTable
