
/**
 * Netview.java
 *
 *
 * Created: Wed Apr  4 17:26:54 2001
 *
 * @author Clemens Bauer
 * @version
 */

package netView;

import netView.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class Netview extends JPanel {
    
    NetViewSource net;

    boolean use3D = false;

    ANNPanel2D ann2d=null;
    ANNPanel3D ann3d=null;
    JScrollPane scrollNet;

    Graph trFcts;
    JScrollPane trFctScrollPane;

    NodePanel neuron;

    boolean empty = true;
    
    public String[] getInNeuronsNames()
    {
    	return net.getInNeuronsDesc();
    }
    
    public String[] getOutNeuronsNames()
    {
    	return net.getOutNeuronsDesc();
    }
    
    public Netview(NetViewSource src) {

	super();
	net =  src;
	
	GridBagLayout g = (new GridBagLayout());
	GridBagConstraints c = new GridBagConstraints();
	this.setLayout(g);
	this.setPreferredSize(new Dimension(800, 600));
		
	if(src == null)
	    {
		// create an empty annPanel
		if (use3D)
		ann3d = new ANNPanel3D(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
		else
		ann2d = new ANNPanel2D(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
	    }
	else
	    {
	    	if (use3D)
		ann3d = new ANNPanel3D(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
                else
		ann2d = new ANNPanel2D(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
	    }

        if (use3D)	
	scrollNet = new JScrollPane(ann3d,
				    JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				    JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	else
	scrollNet = new JScrollPane(ann2d,
				    JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				    JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	// do the layout for the annPanel
	c.weighty = 1.0;
	c.weightx = 0.9;
	c.gridy = 1;
	c.gridx = 0;
	c.fill = GridBagConstraints.BOTH;
	c.gridwidth = 7;
	c.gridheight = 10;
	c.anchor = GridBagConstraints.NORTHWEST;
	g.setConstraints(scrollNet, c);
	
	//	ann.setPreferredSize(new Dimension(500,600));
	scrollNet.setPreferredSize(new Dimension(350,500));

	this.add(scrollNet);


// 	trFcts = new Graph(src.getTrFcts());
// 	trFcts.setPreferredSize(new Dimension(150,src.getTrFcts().length * 100));

// 	trFctScrollPane = new JScrollPane(trFcts,
// 				      JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
// 				      JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
// 	//trFctScrollPane.setPreferredSize(new Dimension(150,getHeight()));
	

// 	c.weightx = 0.3;
// 	c.gridx = 7;
// 	c.gridy = 0;
// 	c.fill = GridBagConstraints.VERTICAL;
// 	c.gridwidth = 2;
// 	c.gridheight = 12;
// 	c.anchor = GridBagConstraints.NORTH;
// 	//	g.setConstraints(trFctScrollPane, c);	
// 	add(trFctScrollPane);

	//class NodePanel handles src == null itself
	neuron = new NodePanel(src);
	// do the layout for the NodePanel 
	c.weightx = 0.1;
	c.gridx = 10;
	c.gridy = 0;
	c.fill = GridBagConstraints.HORIZONTAL;
	c.gridwidth = 5;
	c.gridheight = 8;
	c.anchor = GridBagConstraints.NORTHEAST;
	g.setConstraints(neuron, c);	
	this.add(neuron);

    }

    public void selectedNeuron(int index){
	neuron.setSelected(index);
    }

    public void selectNeuron(int idx){
    	if (use3D)
	   ann3d.selectNeuron(idx);
	else
	   ann2d.selectNeuron(idx);	
    }

    public void setSource(NetViewSource src)
    {
	if(src == null)
	    {
		// create an empty annPanel
		if (use3D)
		{
		   if (ann3d==null)
		   {
		   ann3d = new ANNPanel3D(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
		   }
		   else
		   {
		   ann3d.resetData(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
		   }
		}
		else
		{
		   if (ann2d==null)
		   			
		   ann2d = new ANNPanel2D(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
		   else
		   ann2d.resetData(this,
				     new byte[0][0],
				     new float[0][0],
				     new int[0],
				     new int[0]);
		   
		}				   
	    }
	else
	    {
	    	if (use3D)
	    	{
	    	if (ann3d==null)    	
		   ann3d = new ANNPanel3D(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
		else
		   ann3d.resetData(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
	        }
	        else
	        {
	        if (ann2d==null)    	
		   ann2d = new ANNPanel2D(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
		else
		   ann2d.resetData(this,
				     src.getTopology(),
				     src.getWeights(),
				     src.getInputNodeIndices(),
				     src.getOutputNodeIndices());
	        }
		// die daten mssen noch neu an alles gesendet werden
		// -> Funktionen zum setzen der Informationen fehlen
	    }	
    }
        
}// Netview
